<?php
/* -----------------------------------------------------------------------------
  Plugin     : Translator
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.dnsalias.com
    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information

  PIP classe => manage integration in public interface

  --------------------------------------------------------------------------- */
if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

include_once(TRANSLATOR_PATH.'translator_root.class.inc.php');
  
class Translator_PIP extends Translator_root
{ 
  function Translator_PIP($prefixeTable, $filelocation)
  {
    parent::__construct($prefixeTable, $filelocation);

    $this->load_config();
    $this->init_events();
  }


  /* ---------------------------------------------------------------------------
  Public classe functions
  --------------------------------------------------------------------------- */


  /*
    initialize events call for the plugin
  */
  public function init_events()
  {
    global $lang;

    if($this->my_config['translator_canregister']=='y')
    {
      load_language('plugin_public.lang', TRANSLATOR_PATH);

      // events only trigerred if it's allowed for a translator to register
      parent::init_events();
      add_event_handler('blockmanager_apply', array(&$this, 'blockmanager_apply') );
      add_event_handler('loc_begin_page_tail', array(&$this, 'manage_tail') );
      add_event_handler('register_user', array(&$this, 'user_registered') );
    }
  }

  public function manage_tail( )
  {
    global $page;

    if($page['body_id'] == 'theRegisterPage') { $this->register_page(); }
  }


  public function register_page()
  {
    global $template;
    

    $local_tpl = new Template(TRANSLATOR_PATH."public_templates/", "");
    $local_tpl->set_filename('plugin_resgister', dirname(__FILE__)."/public_templates/register.tpl");

    $template_datas['ASTRANSLATOR']=(isset($_POST['F_REGISTERASTRANSLATOR'])&&($_POST['F_REGISTERASTRANSLATOR']=='on'))?"checked":"";

    $local_tpl->assign("datas", $template_datas);

    $search_code = '/(<form.*register_form.*<\/ul>.*)(<\/fieldset>)/ims';
    $new_code = '$1</fieldset>'.$local_tpl->parse('plugin_resgister', true);

    $template->output=preg_replace($search_code, $new_code, $template->output);
  }

  public function check_for_register()
  {
    global $user;

    if(isset($_POST['F_REGISTERASTRANSLATOR']) && ($_POST['F_REGISTERASTRANSLATOR']=='on'))
    {   
      $this->user_registered(array("id"=>$user['id']));
    }
  }

  public function user_registered($user_prop)
  {
    global $user;

    if(isset($_POST['F_REGISTERASTRANSLATOR']) && ($_POST['F_REGISTERASTRANSLATOR']=='on'))
    {
      $localisation=$this->get_browser_language();
      $nfo=array( 
        'id' => $user_prop['id'],
        'country' => $localisation[1],
        'town' => '',
        'native_language' => $localisation[0],
        'sex' => 'P',
        'birthdate' => '',
        'comment' => '',
        'spoken_language' => ''
      );
      
      $this->add_translator($nfo, ($this->my_config['translator_need_admin_to_be_registered']=='n'));

      if($this->my_config['mail_to_admin']=='y')
      {
        if(!isset($user_prop['username']))
        {
          $user_prop['username'] = $user['username'];
          $user_prop['email'] = $user['email'];
        }

        include_once(PHPWG_ROOT_PATH.'include/functions_mail.inc.php');
        $admin_url = get_absolute_root_url().'admin.php?page=user_list&username='.$user_prop['username'];

        $keyargs_content = array
        (
          get_l10n_args('User: %s', $user_prop['username']),
          get_l10n_args('Email: %s', $user_prop['email']),
          get_l10n_args('', ''),
          get_l10n_args('Admin: %s', $admin_url),
          get_l10n_args('g001_user_asking_to_be_translator_mail_content', $user_prop['username']),
          get_l10n_args('g001_activate_link', get_absolute_root_url().$this->page_link."&f_tabsheet=translators"),
        );

        pwg_mail_notification_admins
        (
          get_l10n_args('g001_user_asking_to_be_translator_mail_subject', $user_prop['username']),
          $keyargs_content
        );    
      }    
    }
  }

  public function blockmanager_apply( $menu_ref_arr )
  {
    global $user, $page;
    $menu = & $menu_ref_arr[0];

    if( 
        ( ($block = $menu->get_block( 'mbTranslator_register' ) ) != null ) &&
        ($user['status']!='guest') &&
        !(is_admin() && !$this->is_translator())
      ) 
    {
      $this->check_for_register();

      $block->set_title(l10n('g001_translation'));
      $block->template = dirname(__FILE__).'/public_templates/menubar_translation.tpl';
      $block->data = array();

      if(!$this->is_translator())
      {
        $block->data['STATUS'] = "not_registered";
      }
      else
      {
        $nfo=$this->get_translator_info();

        if($nfo['adviser']=='false')
        {
          $block->data['STATUS'] = "wait_admin";
        }
        else
        {       
          $block->data['STATUS'] = "ok";
          $block->data['URLUSER'] = $this->page_link."&amp;f_tabsheet=translators&amp;action=edit&amp;user=".$user['id'];
          $block->data['URLTRANSLATE'] = $this->page_link."&amp;f_tabsheet=status";
        }
      }
      

    }
  }

  /*
    return an array
      [0] lang
      [1] country
  */
  public function get_browser_language()
  {
    $returned=array("", "");
    $tmp=explode(",", strtoupper($_SERVER['HTTP_ACCEPT_LANGUAGE']));

    $returned[0]=substr($tmp[0],0,2);
    if(strlen($tmp[0])>2)
    {
      $returned[1]=substr($tmp[0],3,2);
    }
    else
    {
      $returned[1]=$returned[0];
    }
    return($returned);
  }


} // Translator_PIP class


?>
